//配列のコピーメソッド
//@see http://la.ma.la/blog/diary_200510062243.htm
Array.prototype.clone = function(){
	return Array.apply(null,this)
}

/**
 * getCsvData<br>
 * Ajaxでテキストファイルから値を取得。要prototype.js
 */
function getCsvData(fname){
	if(fname == "" || fname == undefined) $("tdiv").innerHTML = "Can not read the file name";
	new Ajax.Request(fname, {
		method: "get",
		onSuccess: doTableformatter,
		onFailure:function(httpObj){
			$("tdiv").innerHTML = "Error occurred when the file is opening.";
		}
	});
}

/**
 * getCsvData<br>
 * Ajaxでテキストファイルから値を取得
 * @param httpObj XMLHttpRequestオブジェクト
 * @author MRB
 * @version 1.0.0
 */
function doTableformatter(httpObj){
	var csvData = httpObj.responseText;
	var LF = String.fromCharCode(10);

	//1列ごと配列に格納
	var arryTexts = csvData.split(LF);
	var arryTables = new Array();

	//csvを取り込んだ配列の最終が""（空文字）なら
	//繰り返しを１回減らす
	var arryTextsLength = arryTexts.length;
	if (arryTexts.last() == "") { //prototype.js Array拡張
		arryTextsLength = arryTextsLength - 1;
	}

	for (i=0; i<arryTextsLength; i++){
		var arryTmps = arryTexts[i].split(",");
		arryTables[i] = new Array(arryTmps.length);
		for (j=0; j<arryTmps.length; j++){
			arryTables[i] = arryTmps.clone();
			arryTmps.clear();
		}
	}
	//フォームより値を取得
	//htmlファイルに合わせて修正要
	var value = csvserchform.txtcsvserch.value;
	var rObj = new RegExp(value);
	var arrSerchResult = new Array();

	//検索
	//ファイルサイズが大きいとき、indexOfや配列を１つ１つ調べるより相当高速
	for (k=0; k<arryTextsLength; k++){
		if (arryTexts[k].match(rObj) || k == 0) { //k==0はテーブルのヘッダー
			arrSerchResult.push(arryTables[k]);
		}
	}

	//id：tdivに結果を追加するために初期化
	$("tdiv").innerHTML = "";
	
	if (arrSerchResult.length > 1) { //必ずヘッダー情報が入っている
		//tableとして出力。テーブル処理用ライブラリ jslb_writetable.js 使用
		//Thanks http://jsgt.org/mt/archives/01/000414.html
		writeTable("tdiv",arrSerchResult);
		
		//テーブルをソートできるようにする。tablesort.js 使用
		//Thanks http://neil.fraser.name/software/tablesort/
		TableSort.init("sorttable");
	} else {
		$("tdiv").innerHTML = "マッチするデータはありません。検索条件を変更してみてください。";
	}
}
//-->
